LOCAL lcPrgPath
lcPrgPath = AddBS(JustPath(SYS(16,0)))

IF !CheckFolder(m.lcPrgPath+"BAD_DBF\", m.lcPrgPath)
ENDIF

#DEFINE MB_ICONQUESTION         32      && Warning query
#DEFINE MB_YESNO                4       && Yes and No buttons
#DEFINE IDOK            1       && OK button pressed
#DEFINE IDYES           6       && Yes button pressed

*********
*	SIMPLE EXAMPLE of cmrepair.app usage in checking folder mode
*
FUNCTION CheckFolder
LPARAMETERS tcPathToCheck, tcPrgPath

LOCAL llAutoRepair, lnRiskRecords, lcLogFile, llSilence, ;
	lnTablesForChecking, lnTablesChecked, lnTablesCorrupted, lnTablesAutoRepaired, llAutoBackup
lnRiskRecords = 5	&& store here number of records you are ready to lose in auto-repair mode
llAutoRepair = .t.	&& store here .f. if you like to see dialog every time the utility is started
lcLogFile = .f.		&& use default place for log file
llSilence = .t.		&& store here .f. if you like to see messages
lnTablesForChecking = 0 	&& [output]
lnTablesChecked = 0			&& [output]
lnTablesCorrupted = 0		&& [output]
lnTablesAutoRepaired = 0	&& [output]
LOCAL a_TableCheckInfo[1]	&& [output] - Array with info for tables in the folder
llAutoBackup = .t.			&& store here .f. if you not like to make backup of repaired tables

lcMessage = 'Folder '+m.tcPathToCheck +CHR(13)+CHR(13)+ 'Start checking?'
IF INLIST(MessageBox(m.lcMessage, MB_ICONQUESTION+MB_YESNO), IDOK,IDYES)

	DO (m.tcPrgPath+'cmrepair.app') WITH m.tcPathToCheck, m.llAutoRepair, m.lnRiskRecords, m.lcLogFile, ;
		m.llSilence, m.lnTablesForChecking, m.lnTablesChecked, m.lnTablesCorrupted, m.lnTablesAutoRepaired, ;
		a_TableCheckInfo, m.llAutoBackup
	?
	? "TablesForChecking:  ", m.lnTablesForChecking
	? "TablesChecked:      ", m.lnTablesChecked
	? "TablesCorrupted:    ", m.lnTablesCorrupted
	? "TablesAutoRepaired: ", m.lnTablesAutoRepaired
	? "For more particulars please see array a_TableCheckInfo"
	
	IF ArrayToCursor(@a_TableCheckInfo, "_aBrowse")
		BROWSE
		USE
	ENDIF
ENDIF
RETURN m.lnTablesForChecking=m.lnTablesChecked AND m.lnTablesCorrupted=0


***
*	Creates cursor with given name from given array (one or two deimensional)
*	Cursor (if created) remains selected
*	From CarlKarsten function aBrow
*
FUNCTION ArrayToCursor
LPARAMETERS taArray, tcCursor
IF EMPTY(m.tcCursor)
	tcCursor = SYS(2015)
ENDIF
LOCAL llOk, lnRows, lnCols, laStru(1), lnI, lnJ, lcTyp, lnSiz, lnDec, lcRow
*	Figure out size of array
lnRows = ALEN(taArray,1)
lnCols = MAX(ALEN(taArray,2), 1)
DIMENSION laStru[m.lnCols, 5]
lcRow = ""
*	Create structure array
FOR lnI = 1 TO lnCols
	lcCol = ALLTRIM(STR(m.lnI))
	laStru(m.lnI,1) = VARTYPE(taArray(1, m.lnI )) + m.lcCol
	laStru(m.lnI,2) = "C"
	lnSiz = 1
	FOR lnJ = 1 TO lnRows
		lnSiz = MAX(m.lnSiz, LEN(TRANS(taArray(lnJ, m.lnI))))
	ENDFOR
	laStru(m.lnI, 3) = m.lnSiz
	laStru(m.lnI, 4) = 0
	* Create "INSERT INTO" values
	IF !EMPTY(m.lcRow)
		lcRow = lcRow + ", "
	ENDIF
	lcRow = lcRow + "TRANSFORM(taArray(m.lnI,"+lcCol+"))"
ENDFOR
*	Make a cursor with fields defined by laStru
llOk = CreTabl1('', @laStru, 0, m.tcCursor) = 0
*CREATE CURSOR (m.tcCursor) FROM ARRAY laStru
IF m.llOk
	* Add rows using a string of transform(taArray(m.lnI,1))...
	FOR lnI = 1 TO m.lnRows
		INSERT INTO (m.tcCursor) VALUES ( &lcRow )
	ENDFOR
	GO TOP
ENDIF
RETURN m.llOk
